﻿using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid.Grouping;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace BindingArrayList
{
    public partial class MainForm : Form
    {
        private DataCollection dataSource;

        public MainForm()
        {
            InitializeComponent();

            Random rand = new Random();
            int r1 = rand.Next(100);
            int r2 = rand.Next(3)-1;
            int r3 = rand.Next(100)-50;

            dataSource = new DataCollection();

            for (int i = 0; i < 6; i++)
            {
                dataSource.Add(new Data() { ID = r1, name = "Line "+r1, val1 = r2, val2 = r3, val3 = r3*2, val4 = r3*r2, val5 = r3-50 });
                r1 = rand.Next(100);
                r2 = rand.Next(3) - 1;
                r3 = rand.Next(100) - 50;
            }

            this.gridGroupingControl1.DataSource = dataSource;

            MyControlCellModel mycontrol = new MyControlCellModel(this.gridGroupingControl1.TableModel);
            this.gridGroupingControl1.TableModel.CellModels["mycontrol"] = mycontrol;
            this.gridGroupingControl1.TableDescriptor.Columns[0].Appearance.AnyRecordFieldCell.CellType = "mycontrol";

            //this.gridGroupingControl1.AllowProportionalColumnSizing = true; 
            this.gridGroupingControl1.TableDescriptor.Columns[0].Width = 100;

            this.gridGroupingControl1.TableDescriptor.GroupedColumns.Add("val1");
            this.gridGroupingControl1.ChildGroupOptions.ShowCaptionSummaryCells = true;
            this.gridGroupingControl1.ChildGroupOptions.ShowSummaries = false;
            this.gridGroupingControl1.ChildGroupOptions.CaptionSummaryRow = "Sum";
            this.gridGroupingControl1.ChildGroupOptions.CaptionText = "{CategoryName}: {Category}";

            GridSummaryColumnDescriptor scd2 = new GridSummaryColumnDescriptor("Sum2", SummaryType.Int32Aggregate, "val2", "{Sum:#}");
            GridSummaryRowDescriptor srd = new GridSummaryRowDescriptor("Sum", "Summary", new GridSummaryColumnDescriptor[] { scd2 });
            srd.Visible = false;
            this.gridGroupingControl1.TableDescriptor.SummaryRows.Add(srd);

            this.gridGroupingControl1.SourceListListChangedCompleted += gridGroupingControl1_SourceListListChangedCompleted;


        }

        void gridGroupingControl1_SourceListListChangedCompleted(object sender, TableListChangedEventArgs e)
        {
            if (e.ListChangedType == ListChangedType.ItemChanged)
            {
                int newvalue = Convert.ToInt32(this.gridGroupingControl1.Table.Records[e.NewIndex].GetValue("val2").ToString());

                //The cell type is correctly mycontrol
                Console.WriteLine(e.NewIndex + " : " + this.gridGroupingControl1.Table.GetTableCellStyle(this.gridGroupingControl1.Table.Records[e.NewIndex],"ID").CellType);

                //**************************************************************
                // IF YOU UNCOMMENT THIS LINE YOU GET AN ERROR: HOW CAN I DO TO CALL THE METHOD UPDATE ON MYCONTROL?

                //((MyControl)this.gridGroupingControl1.Table.GetTableCellStyle(this.gridGroupingControl1.Table.Records[e.NewIndex], "ID").Control).Update(newvalue);

                //**************************************************************
            }
        }      

        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.EnableVisualStyles();
            Application.Run(new MainForm());
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Data d = new Data() { ID = 0, name = "Line Mod", val1 = 10, val2 = 10, val3 = 10, val4 = 10, val5 = 10 };
            dataSource[1] = d;
        }

    }
}
